



// *** Hilfsprogramme fuer CONOUT ***







procedure Kursor_Ausschalten;
begin

  Kursor_sichtbar:=false;

  Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=Kursor_Puffer;

  Kursor_Schleife:=0;

end Kursor_Ausschalten;



procedure Kursor_Einschalten;
begin

  Kursor_sichtbar:=true;

  Kursor_Puffer:=Zeichen_Matrix[Y_KUR_POS,X_KUR_POS];

  Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=$5F;  // '_';

  Kursor_Schleife:=0;

end Kursor_Einschalten;






procedure Kursor_Umschalten;
begin

  if Kursor_sichtbar then
    Kursor_Ausschalten;
  else
    Kursor_Einschalten;
  endif;
end Kursor_Umschalten;








procedure Clear_Matrix;
begin

  for Y_KUR_POS:=0 to max_Zeilen do

    for X_KUR_POS:=0 to max_Spalten do

      Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=Fuellzeichen;

    endfor;

  endfor;

  X_KUR_POS:= 0;
  Y_KUR_POS:= 0;

end Clear_Matrix;






// *****************************
// *  CONOUT und ESC-Sequenzen *
// *****************************



procedure CURSOR_HOME;
begin

  X_KUR_POS:= 0;
  Y_KUR_POS:= 0;

  TermMode:=Normal_TM;

end CURSOR_HOME;


procedure Escape_Reset;
begin
  CSI_Parameter1:=0;
  CSI_Parameter2:=0;
  CSI_Parameter3:=0;
  TermMode:=Normal_TM;
  Escape_Sequenz:='';
end Escape_Reset;



procedure Escape_Fehler;
var
  ESC_Zaehler : Byte;
  ESC_Laenge  : Byte;
  ESC_Zeichen : Char;

  X_KUR_POS2 : Word;
  Y_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;
  Y_KUR_POS2:=Y_KUR_POS;

  CURSOR_HOME;

  Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=$45; // E
  INC(X_KUR_POS);

  Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=$53; // S
  INC(X_KUR_POS);

  Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=$43; // C
  INC(X_KUR_POS);

  ESC_Laenge:=Length(Escape_Sequenz);

  for ESC_Zaehler:=1 to ESC_Laenge do
    ESC_Zeichen:=Escape_Sequenz[ESC_Zaehler];
    L_Zeichen:=CharToByte(ESC_Zeichen);
    Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=L_Zeichen;
    INC(X_KUR_POS);
  endfor;

  Escape_Reset;

  X_KUR_POS:=X_KUR_POS2;
  Y_KUR_POS:=Y_KUR_POS2;

end Escape_Fehler;
















// Erhoeht die Kursorposition der aktuellen Zeile um 1
//     (wenn die max_Spalten noch nicht erreicht ist)
procedure CURSOR_RIGHT;
begin

  if X_KUR_POS<max_Spalten then
    Inc(X_KUR_POS);
  endif;

  TermMode:=Normal_TM;

end CURSOR_RIGHT;




procedure CURSOR_LEFT;
begin

  if X_KUR_POS>0 then
    DEC(X_KUR_POS);
  endif;

  TermMode:=Normal_TM;

end CURSOR_LEFT;





procedure CURSOR_UP;
begin

  if Y_KUR_POS>0 then
    DEC(Y_KUR_POS);
  endif;

  TermMode:=Normal_TM;

end CURSOR_UP;





// Erhoeht die Kursorposition der aktuellen Zeile um 1
//     (wenn die max_Spalten noch nicht erreicht ist)
procedure CURSOR_DOWN;
begin

  if Y_KUR_POS<max_Zeilen then
    Inc(Y_KUR_POS);
  endif;

  TermMode:=Normal_TM;

end CURSOR_DOWN;





procedure CURSOR_TAB;
begin

  X_KUR_POS:=X_KUR_POS div 8;
  X_KUR_POS:=X_KUR_POS + 1;
  X_KUR_POS:=X_KUR_POS * 8;

  TermMode:=Normal_TM;

end CURSOR_TAB;




procedure CURSOR_COUNTER_UP(counter : Word);
begin

  if Y_KUR_POS>counter then
    Y_KUR_POS:=Y_KUR_POS-counter;
  else
    Y_KUR_POS:=0;
  endif;

  TermMode:=Normal_TM;

end CURSOR_COUNTER_UP;










{ *** DELETE *** }



procedure RUN_DEL;
begin

  if X_KUR_POS>0 then
    Dec(X_KUR_POS);
    Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=Fuellzeichen;
  endif;

  TermMode:=Normal_TM;

end RUN_DEL;



// Loeschen von Kursorpossition bis zum Zeilenende
procedure DELETE_EOL;
var
  X_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;

  for X_KUR_POS:=X_KUR_POS2 to max_Spalten do

    Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=Fuellzeichen;

  endfor; { for X_KUR_POS:=X_KUR_POS2 to max_Spalten do }

  X_KUR_POS:=X_KUR_POS2;

end DELETE_EOL;






// Loeschen von Anfang bis Kursorpossition
procedure DELETE_BOL;
var
  X_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;

  for X_KUR_POS:=0 to X_KUR_POS2 do

    Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=Fuellzeichen;

  endfor; { for X_KUR_POS:=0 to X_KUR_POS2 do }

  X_KUR_POS:=X_KUR_POS2;

end DELETE_BOL;





// Loeschen der gesammten Zeile auf Y-Kursorposition
procedure DELETE_LINE;
var
  X_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;

  for X_KUR_POS:=0 to max_Spalten do

    Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=Fuellzeichen;

  endfor; { for X_KUR_POS:=0 to max_Spalten do }

  X_KUR_POS:=X_KUR_POS2;

end DELETE_LINE;







// Loeschen der letzten Zeile
procedure DELETE_last_LINE;
var
  X_KUR_POS2 : Word;
  Y_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;
  Y_KUR_POS2:=Y_KUR_POS;

  Y_KUR_POS:=max_Zeilen;

  for X_KUR_POS:=0 to max_Spalten do

    Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=Fuellzeichen;

  endfor; { for X_KUR_POS:=0 to max_Spalten do }

  X_KUR_POS:=X_KUR_POS2;
  Y_KUR_POS:=Y_KUR_POS2;

end DELETE_last_LINE;





// Loeschen der aktuellen Zeile auf der Kursorposition
// und ScreenRoll
procedure DELETE_LINE_SCR_ROLL;
var
  X_KUR_POS2 : Word;
  Y_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;
  Y_KUR_POS2:=Y_KUR_POS;

  if Y_KUR_POS<=max_Zeilen then

    for Y_KUR_POS:=Y_KUR_POS2 to max_Zeilen do

      for X_KUR_POS:=0 to max_Spalten do

        Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=Fuellzeichen;

      endfor; { for Kur_Pos_X_Cnt:=0 to max_Spalten do }

    endfor; { for Kur_Pos_Y_Cnt:=Y_KUR_POS to max_Zeilen2 do }


  endif; { if Y_KUR_POS<=22 then }

  X_KUR_POS:=X_KUR_POS2;
  Y_KUR_POS:=Y_KUR_POS2;

end DELETE_LINE_SCR_ROLL;







// neue Zeile der aktuellen Zeile auf der Kursorposition
// und ScreenRoll
procedure INSERT_LINE_SCR_ROLL;
var
  X_KUR_POS2 : Word;
  Y_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;
  Y_KUR_POS2:=Y_KUR_POS;

  if Y_KUR_POS<=max_Zeilen then

    for Y_KUR_POS:=max_Zeilen downto Y_KUR_POS2 do

      for X_KUR_POS:=0 to max_Spalten do

        Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=Fuellzeichen;

      endfor; { for X_KUR_POS:=0 to max_Spalten do }

    endfor; { for Y_KUR_POS:=max_Zeilen downto Y_KUR_POS2 do }

  endif; { if Y_KUR_POS<=max_Zeilen then }

  X_KUR_POS:=X_KUR_POS2;
  Y_KUR_POS:=Y_KUR_POS2;

end INSERT_LINE_SCR_ROLL;






// Loeschen aller Zeilen von Kursorposition
// bis Bildschirmende
procedure ERASE_DOWN;
var
  X_KUR_POS2 : Word;
  Y_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;
  Y_KUR_POS2:=Y_KUR_POS;

  for Y_KUR_POS:=Y_KUR_POS2 to max_Zeilen do

    for X_KUR_POS:=0 to max_Spalten do

      Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=Fuellzeichen;

    endfor; { for Kur_Pos_Cnt:=0 to 79 do }

  endfor;

  X_KUR_POS:=X_KUR_POS2;
  Y_KUR_POS:=Y_KUR_POS2;

end ERASE_DOWN;






// Verschieben aller Zeilen um eins nach oben
// die erste Zeile wird ueberschrieben
procedure Screen_Roll;
var
  X_KUR_POS2 : Word;
  Y_KUR_POS2 : Word;
  one_Byte : Byte;

begin

  // Verschieben von Zeile 1 bis Ende-2 um 1 nach oben
  for Y_KUR_POS:=0 to max_Zeilen-1 do

    for X_KUR_POS:=0 to max_Spalten do

      one_Byte:=Zeichen_Matrix[Y_KUR_POS+1,X_KUR_POS];
      Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=one_Byte;

    endfor; { for Kur_Pos_X_Cnt:=0 to max_Spalten2 do }

  endfor; { for Kur_Pos_Y_Cnt:=0 to max_Zeilen2-1 do }


  // Loeschen der letzten Zeile
  Y_KUR_POS:=max_Zeilen;

  for X_KUR_POS:=0 to max_Spalten do

    Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=Fuellzeichen;

  endfor; { for X_KUR_POS:=0 to max_Spalten do }

  X_KUR_POS:= 0;
  Y_KUR_POS:= max_Zeilen;

end Screen_Roll;









procedure SET_CURSOR_POSITION(Zeile, Spalte : Word); // bezogen auf 0,0 !!!
begin

  // 1. Zeile setzen
  X_KUR_POS:=Spalte;

  if X_KUR_POS>max_Spalten then
    X_KUR_POS:=max_Spalten;
  endif;

  // 2. Spalte setzen
  Y_KUR_POS:=Zeile;

  if Y_KUR_POS>max_Zeilen then
    Y_KUR_POS:=max_Zeilen;
  endif;

end SET_CURSOR_POSITION;




procedure Carridge_Return;
begin

  X_KUR_POS:=0;

end Carridge_Return;




procedure LINE_FEED;
begin

  if Y_KUR_POS<max_Zeilen then
    INC(Y_KUR_POS);
  else
    Screen_Roll;
  endif;

end LINE_FEED;







// *********************
// *** TERMINAL MODE ***
// *********************





procedure Normal_Terminal_Mode;
begin

  case L_Zeichen of

    $01 :    // 01 = Kursor auf Anfang (0,0)
             CURSOR_HOME;
     |

    $04 :    // 01 = Kursor nach Rechts
             CURSOR_RIGHT;
     |

    $05 :    // 01 = Kursor nach Oben
             CURSOR_UP;
     |

    $07 :    // 07 = BELL - Glocke
             //RUN_BELL;
     |

    $09 :    // 09 = Tabulator
             CURSOR_TAB;
     |

    $0A :   // 0AH = Zeilenschaltung (Line Feed)
            LINE_FEED;
     |

    $0C :   // 0CH = Bildschirm loeschen (Clear Screen)
            Clear_Matrix;
     |

    $0D :   // 0DH = Wagenruecklauf (Carridge Return)
            Carridge_Return;
     |

    $13 :   // 13H = Kursor nach Links
            CURSOR_LEFT;
     |

    $16 :   // ab Cursorposition bis Zeilenende loeschen
            DELETE_EOL;
     |

    $1B :   // ESC-Modus
            TermMode:=IBM_ESC_TM;

    |

    $7F :   RUN_DEL;

    |

  else


    if L_Zeichen>=$20 then
      if L_Zeichen<=$7F then
        if X_KUR_POS<=max_Spalten then

          Zeichen_Matrix[Y_KUR_POS,X_KUR_POS]:=L_Zeichen;

          Kursor_Puffer:=L_Zeichen;

          CURSOR_RIGHT;

        endif; { if X_KUR_POS<80 then }
      endif; { if Zeichen<=$7F then }
    endif; { if Zeichen>=$20 then  }

  endcase; { case Zeichen of }


end Normal_Terminal_Mode;














procedure IBM_ESC_Terminal_Mode;
begin

  case L_Zeichen of

    $5B : TermMode:=IBM_CSI_TM; // Control Sequence Introducer (CSI) = ESC [
    |

  else
    Escape_Fehler;
  endcase;

end IBM_ESC_Terminal_Mode;




procedure Set_Display_Attributes(DispAttr : Word);

begin

  case DispAttr of

    00 :  // ESC [ 0 m = Alle Attribute AUS (Reset all attributes)
    |

    01 :  // ESC [ 1 m = Fett ein
    |

    04 :  // ESC [ 4 m = Unterstreichen
    |

    05 :  // ESC [ 5 m = Blinken EIN
    |

    07 :  // ESC [ 7 m = Invertierte Darstellung
    |

    08 :  // ESC [ 8 m = Versteckt ein
    |

  endcase; { case L_Zeichen of }


end Set_Display_Attributes;





procedure IBM_CSI_Terminal_Mode;
begin

  case L_Zeichen of

    $30..$39 : CSI_Parameter1:=ByteToWord(L_Zeichen)-$30;
               TermMode:=IBM_CSI_TM_Par_1;
    |

    $48 : // "H" -- MOVE CURSOR = ESC [ H
          // SET_CURSOR_POSITION(0,0);
          CURSOR_HOME;
          Escape_Reset;
    |

    $4A : // "J" -- Erase Down = ESC [ J
          // Erases the screen from the current line down to the bottom of the screen.
          ERASE_DOWN;
          Escape_Reset;
    |

    $4B : // Loeschen bis Zeilenende = ESC [ K
          DELETE_EOL;
          Escape_Reset;
    |

    $66 : // Character Attributes = ESC [ f
          CURSOR_HOME;
          Escape_Reset;
    |

    $6D : // Turn off character attributes = ESC [ m
          Set_Display_Attributes(0);
          Escape_Reset;
    |

  else
    Escape_Fehler;
  endcase;

end IBM_CSI_Terminal_Mode;











// IBM_CSI_TM_Par_1
procedure IBM_CSI_Par_1_Terminal_Mode;
var
  Zaehler : Word;
begin

  case L_Zeichen of

    $30..$39 : CSI_Parameter1:=CSI_Parameter1*10;
               CSI_Parameter1:=CSI_Parameter1+ByteToWord(L_Zeichen);
               CSI_Parameter1:=CSI_Parameter1-$30;

               TermMode:=IBM_CSI_TM_Par_1;
     |

    $3B :      // ";"
	       // ESC [ Pn1 ; PN2 H oder
	       // ESC [ Pn1 ; PN2 f oder
               // ESC [ Pn1 ; PN2 m oder
	       // Xterm 256 colors - ESC[48;5;BCOLOR m oder
	       // Xterm 256 colors - ESC[38;5;FCOLOR m
               TermMode:=IBM_CSI_TM_Par_2;
     |

    $41 :      // CUU -- Cursor Up = ESC [ Pn A
               CURSOR_COUNTER_UP(CSI_Parameter1);
               Escape_Reset;
     |




    $4A : // Zeilen loeschen = ESC [ Pn J
         // ED -- Erase In Display = ESC [ Pn J
               // This sequence erases some or all of the characters in the
               // display according to the parameter. Any complete line
               // erased by this sequence will return that line to single
               // width mode.

               case CSI_Parameter1 of
                 0 : ERASE_DOWN;                      // Erase to End of Screen
                 |
                 1 : DELETE_BOL;                      // Erase from start of the screen
                                                      // to the active position, inclusive
                 |
                 2 : // Loeschen gesammte zeile
                     Clear_Matrix;
                 |

               else
                 Escape_Fehler;
               endcase;

               Escape_Reset;

     |

    $4B : // Zeilen loeschen = ESC [ Pn K

          case CSI_Parameter1 of

            0 : // Loeschen bis Zeilenende
                DELETE_EOL;
            |

            1 : // Loeschen von Anfang bis Kursor
                DELETE_BOL;
            |

            2 : // Loeschen gesammte zeile
                DELETE_LINE;
            |

          else
            Escape_Fehler;
          endcase;
          Escape_Reset;
     |


    $4C : // INSERT_LINE_SCR_ROLL = ESC [ Pn L
          for Zaehler:=0 to CSI_Parameter1-1 do
            INSERT_LINE_SCR_ROLL;
          endfor;
          Escape_Reset;
     |

    $4D : // "M" DELETE_LINE_SCR_ROLL = ESC [ Pn M
          for Zaehler:=0 to CSI_Parameter1-1 do
            DELETE_LINE_SCR_ROLL;
          endfor;
          Escape_Reset;
     |

    $6D : // "m" Set_Display_Attributes = ESC [ m
          Set_Display_Attributes(CSI_Parameter1);
          Escape_Reset;
     |

  else
    Escape_Fehler;
  endcase; { case L_Zeichen of }

end IBM_CSI_Par_1_Terminal_Mode;








// IBM_CSI_TM_Par_2
procedure IBM_CSI_Par_2_Terminal_Mode;
begin

  case L_Zeichen of

    $30..$39 : CSI_Parameter2:=CSI_Parameter2*10;
               CSI_Parameter2:=CSI_Parameter2+ByteToWord(L_Zeichen);
               CSI_Parameter2:=CSI_Parameter2-$30;

               TermMode:=IBM_CSI_TM_Par_2;
    |


    $48 : // "H" -- MOVE CURSOR = ESC [ Pn1 ; PN2 H
          SET_CURSOR_POSITION(CSI_Parameter1,CSI_Parameter2);
          Escape_Reset;
    |

    $66 : // "f" -- MOVE CURSOR = ESC [ Pn1 ; PN2 f
          SET_CURSOR_POSITION(CSI_Parameter1,CSI_Parameter2);
          Escape_Reset;
    |

  else
    Escape_Fehler;
  endcase; { case L_Zeichen of }


end IBM_CSI_Par_2_Terminal_Mode;





procedure IBM_CSI_Par_3_Terminal_Mode;
begin


  case L_Zeichen of

    $30..$39 : CSI_Parameter3:=CSI_Parameter3*10;
               CSI_Parameter3:=CSI_Parameter3+ByteToWord(L_Zeichen);
               CSI_Parameter3:=CSI_Parameter3-$30;

               TermMode:=IBM_CSI_TM_Par_3;

    |

  else
    Escape_Fehler;
  endcase; { case L_Zeichen of }


end IBM_CSI_Par_3_Terminal_Mode;







procedure CONOUT;
var
  CON_Zeichen : Char;
begin

  Kursor_Schleife:=0;

  if Kursor_sichtbar then
    Kursor_Ausschalten;
  endif;


  // Abspeichern der Escape-Steuerzeichen fuer die
  // Anzeige der nicht ausgewerteter Sequenzen im Fehlerfall
  if TermMode<>Normal_TM then
    CON_Zeichen:=ByteToChar(L_Zeichen);
    Escape_Sequenz:=Escape_Sequenz+CON_Zeichen;
  endif;



  case TermMode of

    Normal_TM            : Normal_Terminal_Mode;
    |

    IBM_ESC_TM           : IBM_ESC_Terminal_Mode;
    |

    IBM_CSI_TM           : IBM_CSI_Terminal_Mode;
    |

    IBM_CSI_TM_Par_1     : IBM_CSI_Par_1_Terminal_Mode;
    |

    IBM_CSI_TM_Par_2     : IBM_CSI_Par_2_Terminal_Mode;
    |

    IBM_CSI_TM_Par_3     : IBM_CSI_Par_3_Terminal_Mode;
    |

  endcase;

end CONOUT;






procedure Text_an_CONOUT;
var
  c1 : Char;
  Laenge : Byte;
  b1 : Byte;
begin

  Laenge:=Length(Ausgabe_Text);
  for b1:=1 to Laenge do
    c1:=Ausgabe_Text[b1];
    L_Zeichen:=CharToByte(c1);
    CONOUT;
  endfor;

end Text_an_CONOUT;




procedure CR_LF_an_CONOUT;
begin

  L_Zeichen:=CR;
  CONOUT;
  L_Zeichen:=LF;
  CONOUT;

end CR_LF_an_CONOUT;









procedure INIT_CONOUT;
begin

  TermMode:=Normal_TM;

  Clear_Matrix;

end INIT_CONOUT;



              
