PROGRAM TXTVGA3;

DEVICE = mega328p;

{$I mega328P_Register.INC}


CONST

  // Frequenz = 24.000.000 Hz; // 790
  //CTC_WERT = 3175*24/100 -> 24.. ist Frequenz in MHz
  CTC_WERT : Word = 760;


  max_Spalten : Word = 77;   // 0..77 = 78
  max_Zeilen  : Word = 23;   // 0..23 = 24

  Fuellzeichen : Byte = $20;  // Leerzeichen
//  Fuellzeichen : Byte = $2E;  //  Punkt


  // TerminalMode
  Normal_TM            : Byte = 0;
  IBM_ESC_TM           : Byte = 1;
  IBM_CSI_TM           : Byte = 2;
  IBM_CSI_TM_Par_1     : Byte = 3;
  IBM_CSI_TM_Par_2     : Byte = 4;
  IBM_CSI_TM_Par_3     : Byte = 5;
  IBM_GRAFIK_Par_1_TM  : Byte = 6;
  IBM_GRAFIK_Par_2_TM  : Byte = 7;

  CR : Byte = $0D;
  LF : Byte = $0A;

{$I VLINE.INC}

VAR

{
B0 - VSYNC  - A -> L
B1 - HSYNC  - A -> L
B2 - LED_GN - A -> L
B3 - CE_CLK - A -> L
B4 - S/L    - A -> L
}

  VSYNC[PortB,0]  : bit;    // VSYNC
  HSYNC[PortB,1]  : bit;    // HSYNC
  Kontroll_LED[PortB,2] : bit;    // Kontroll-LED
  CE_CLK[PortB,3] : bit;    // CE_CLK
  SL[PortB,4]     : bit;    // Shift - /Load


{
D0..D7 - Daten fuer 74HC165
}


  Wert_yl, Wert_yh,
  Wert_zh, Wert_BWS_H, Wert_BWS_L : Byte;



  TermMode : Byte;

  CSI_Parameter1, CSI_Parameter2,
  CSI_Parameter3 : Word;

  Escape_Sequenz : String[10];

  Ausgabe_Text : String[10];

  LED_ein : Word;

  // Kursor-Variablen
  Kursor_sichtbar : Boolean;
  Kursor_Schleife : Word;
  Kursor_Puffer : Byte;


  // Zeichen-Matrix und Farb-Matrix
  Zeichen_Matrix : Array [0..max_Zeilen,0..max_Spalten] of Byte;


  X_KUR_POS, Y_KUR_POS : Word;


  L_Zeichen : Byte;





{$I mega328P_TC.INC}



// *** INITIALISIERUNG ***


procedure InitPorts;
begin

{
B0 - VSYNC  - A -> L
B1 - HSYNC  - A -> L
B2 - LED_GN - A -> L
B3 - CE_CLK - A -> L
B4 - S/L    - A -> L
}
  //       EEEAAAAA
  DDRB:=  %00011111;

  // PORT B Voreinstellungen
  PORTB:= %00000000;


{
C0..C3 - Daten fuer ITP3

C4 - DS - E -> L
C5 - DR - E -> L
}
  // PORT C Voreinstellungen
  PortC:= %00000000;

  //       EEEEEEEE
  DDRC:=  %00000000;


{
D0..D7 - Daten fuer 74HC165 - alles Ausgaenge
}
  // PORT D Voreinstellungen
  PortD:= %00000000;

  //       AAAAAAAA
  DDRD:=  %11111111;


end InitPorts;





isr TIMER1_COMPA;
begin

{$I VIDEO.INC}

end TIMER1_COMPA;





{$I CONOUT.INC}

{$I ITP3_CLI_PORT.INC}
{$I ITP3_CLI_PRG.INC}





BEGIN


  InitPorts;


  SetBit(SL);

  ClearBit(VSYNC);
  ClearBit(HSYNC);


  Init_TIMER1_COMPA(CTC_WERT);

  Wert_yl:=0;
  Wert_yh:=0;



  Wert_zh:=32;



ASM;

 ldi   R16, low(Zeichen_Matrix)
 sts   Wert_BWS_L, R16

 ldi   R16, high(Zeichen_Matrix)
 sts   Wert_BWS_H, R16

ENDASM;


  Init_CONOUT;


  Ausgabe_Text:='TXTVGA2';
  Text_an_CONOUT;
  Ausgabe_Text:=' Version';
  Text_an_CONOUT;
  Ausgabe_Text:=' 1.0';
  Text_an_CONOUT;
  CR_LF_an_CONOUT;

  Ausgabe_Text:='(c) by ';
  Text_an_CONOUT;
  Ausgabe_Text:=' Ronald';
  Text_an_CONOUT;
  Ausgabe_Text:=' Daleske';
  Text_an_CONOUT;
  CR_LF_an_CONOUT;


  Kursor_Schleife:=0;
  Kursor_sichtbar:=false;
  Kursor_Puffer:=$20;

  LED_ein:=0;


  EnableInts;



  loop

    ITP3_Server_Abfrage;


    INC(Kursor_Schleife);

    if Kursor_Schleife>11000 then
      Kursor_Umschalten;
    endif;

    if LED_ein>0 then
      SetBit(Kontroll_LED);
      Dec(LED_ein);
    else
      ClearBit(Kontroll_LED);
    endif;


  endloop;


{$I font6x16.INC}

END TXTVGA3.
